<?php

namespace TopThinkCloud\Notification\Channel;

use think\App;
use think\Cache;
use TopThinkCloud\Client;
use TopThinkCloud\OAuth;
use yunwuxin\Notification;
use yunwuxin\notification\Channel;

class Cloud extends Channel
{
    protected $app;
    protected $cache;

    public function __construct(App $app, Cache $cache)
    {
        $this->app   = $app;
        $this->cache = $cache;
    }

    public function send($notifiable, Notification $notification)
    {
        $data = $this->getMessage($notifiable, $notification);

        $this->getClient()->notification()->create($data);
    }

    protected function getClient()
    {
        $client = $this->app->make(Client::class);

        $token = $this->cache->remember('cloud-access-token', function () {
            return $this->app->make(OAuth::class)->getAccessToken();
        }, 60 * 5);

        $client->authenticate($token);

        return $client;
    }
}
